// -----------------------------------------------------------------------------
// gyvendinti ADT vienakrypt sra ir papildyti j operacija srao riavimas
// burbulo metodu. Riuojami duomenys - eioliktainiai skaiiai gyvendinami
// kaip eiluts.

program bubbleSort;

uses SysUtils;

const _CH = 'q'; // programos darbo pabaiga zymintis simbolis

type pSarasas = ^elem;
     elem = record
                    inf:   string;
                    test:  string;
                    kitas: pSarasas;
            end;

//------------------------------------------------------------| saraso sukurimas
procedure uzpildyti(var pPradinis: pSarasas; var count: integer);

var klaida, inf: integer;
    pLaikinas:   pSarasas;
    input:       string;
    
begin

    count := 0;

    new(pPradinis);
    new(pLaikinas);
    
    pLaikinas := pPradinis;
    
    while input <> _CH do
    begin
    
        writeln('Iveskite ', count+1, '-aji saraso elementa: ');
        readln(input);

        if(input[1] = '$') then
        begin

            val(input, inf, klaida);

            if klaida = 0 then
            begin

                if count >= 1 then
                begin
                    new(pLaikinas^.kitas);
                    pLaikinas := pLaikinas^.kitas;
                end;

                pLaikinas^.inf := inf;
                inc(count);
            end
            else
                if input <> _CH then
                    writeln('Klaida: netinkamas formatas. Bandykite dar karta: ');
        end
        else
            if input <> _CH then
                writeln('Klaida: neivedete simbolio "$". Bandykite dar karta: ');
    end;


end;
//------------------------------------------------------------------------------

//-----------------------------------------------------------| saraso rusiavimas

procedure rusiuoti(var pPradinis: pSarasas; count: integer);

var pLaikinas, pPirmas, pPaskutinis: pSarasas;
    tmp:                             integer;

begin

    pPirmas := pPradinis;
    pLaikinas := pPradinis;

    while (pLaikinas <> nil) do pLaikinas := pLaikinas^.kitas;

    pPaskutinis := pLaikinas;

    while (pPirmas <> pPaskutinis) do
    begin
        pLaikinas := pPirmas;

        while (pLaikinas^.kitas <> pPaskutinis) do
        begin

            if pLaikinas^.inf > pLaikinas^.kitas^.inf then
            begin
                tmp := pLaikinas^.inf;
                pLaikinas^.inf := pLaikinas^.kitas^.inf;
                pLaikinas^.kitas^.inf := tmp;
            end;

            pLaikinas := pLaikinas^.kitas;
        end;

        pPaskutinis := pLaikinas;
    end;

end;
//------------------------------------------------------------------------------

//------------------------------------------------------------| saraso isvedimas
procedure spausdinti(var pPradinis: pSarasas; count: integer);

var pLaikinas: pSarasas;
    i:         integer;

begin

    if count > 0 then
    begin
        pLaikinas := pPradinis;

        for i := 1 to count do
        begin
            writeln(i, '-as elementas: ', IntToHex(pLaikinas^.inf, 8), ' (', pLaikinas^.inf, ')');
            pLaikinas := pLaikinas^.kitas;
        end;
    end
    else writeln(' - sarasas tuscias');

end;
//------------------------------------------------------------------------------

//-----------------------------------------------------| atminties atlaisvinimas
procedure atlaisvinti(var pPradinis: pSarasas);

var pLaikinas: pSarasas;

begin

    while pPradinis <> nil do
    begin
        pLaikinas := pPradinis^.kitas;
        dispose(pPradinis);
        pPradinis := pLaikinas;
    end;

end;
//------------------------------------------------------------------------------

var pPradinis: pSarasas;
    count:    integer;

begin

    writeln('Programa rusiuoja sesioliktainius (hex) skaicius.');
    writeln;
    writeln('Naudojimas:');
    writeln(' - ivedami simboliai - tik skaiciai;');
    writeln(' - pirmasis simbolis visada privalo buti "$" (dolerio) zenklas;');
    writeln(' - programos darbas nutraukiamas ivedus "', _CH, '" simboli.');
    writeln;
    writeln;

    // uzpildom
    uzpildyti(pPradinis, count);

    writeln;
    writeln('Jusu ivestas sarasas:');

    // rusiuojam
    rusiuoti(pPradinis, count);

    // spausdinam
    spausdinti(pPradinis, count);
    
    // atlaisvinam atminti
    atlaisvinti(pPradinis);

    readln;

end.
